Index: frontends/php/include/httptest.inc.php
===================================================================
--- frontends/php/include/httptest.inc.php	(revision 38884)
+++ frontends/php/include/httptest.inc.php	(working copy)
@@ -70,14 +70,14 @@
 			return false;
 		}
 
-		if(!$httpstep_data = DBfetch(DBselect('select httpstepid from httpstep where httptestid='.$httptestid.' and name='.zbx_dbstr($name)))){
+		if(!$httpstep_data = DBfetch(DBselect('select httpstepid from httpstep where httptestid='.zbx_dbstr($httptestid).' and name='.zbx_dbstr($name)))){
 
 			$httpstepid = get_dbid("httpstep","httpstepid");
 
 			if (!DBexecute('insert into httpstep'.
 				' (httpstepid, httptestid, name, no, url, timeout, posts, required, status_codes) '.
-				' values ('.$httpstepid.','.$httptestid.','.zbx_dbstr($name).','.$no.','.
-				zbx_dbstr($url).','.$timeout.','.
+				' values ('.$httpstepid.','.$httptestid.','.zbx_dbstr($name).','.zbx_dbstr($no).','.
+				zbx_dbstr($url).','.zbx_dbstr($timeout).','.
 				zbx_dbstr($posts).','.zbx_dbstr($required).','.zbx_dbstr($status_codes).')'
 				)) return false;
 		}
@@ -85,9 +85,9 @@
 			$httpstepid = $httpstep_data['httpstepid'];
 
 			if (!DBexecute('update httpstep set '.
-				' name='.zbx_dbstr($name).', no='.$no.', url='.zbx_dbstr($url).', timeout='.$timeout.','.
+				' name='.zbx_dbstr($name).', no='.zbx_dbstr($no).', url='.zbx_dbstr($url).', timeout='.zbx_dbstr($timeout).','.
 				' posts='.zbx_dbstr($posts).', required='.zbx_dbstr($required).', status_codes='.zbx_dbstr($status_codes).
-				' where httpstepid='.$httpstepid)) return false;
+				' where httpstepid='.zbx_dbstr($httpstepid))) return false;
 		}
 
 		$monitored_items = array(
@@ -114,12 +114,12 @@
 		foreach($monitored_items as $item){
 			$item_data = DBfetch(DBselect('select i.itemid,i.history,i.trends,i.delta,i.valuemapid '.
 				' from items i, httpstepitem hi '.
-				' where hi.httpstepid='.$httpstepid.' and hi.itemid=i.itemid '.
-				' and hi.type='.$item['httpstepitemtype']));
+				' where hi.httpstepid='.zbx_dbstr($httpstepid).' and hi.itemid=i.itemid '.
+				' and hi.type='.zbx_dbstr($item['httpstepitemtype'])));
 
 			if(!$item_data){
 				$item_data = DBfetch(DBselect('select i.itemid,i.history,i.trends,i.delta,i.valuemapid '.
-					' from items i where i.key_='.zbx_dbstr($item['key_']).' and i.hostid='.$hostid));
+					' from items i where i.key_='.zbx_dbstr($item['key_']).' and i.hostid='.zbx_dbstr($hostid)));
 			}
 
 			$item_args = array(
@@ -178,11 +178,11 @@
 
 			$httpstepitemid = get_dbid('httpstepitem', 'httpstepitemid');
 
-			DBexecute('delete from httpstepitem where itemid='.$itemid);
+			DBexecute('delete from httpstepitem where itemid='.zbx_dbstr($itemid));
 
 			if (!DBexecute('insert into httpstepitem'.
 				' (httpstepitemid, httpstepid, itemid, type) '.
-				' values ('.$httpstepitemid.','.$httpstepid.','.$itemid.','.$item['httpstepitemtype'].')'
+				' values ('.$httpstepitemid.','.zbx_dbstr($httpstepid).','.zbx_dbstr($itemid).','.zbx_dbstr($item['httpstepitemtype']).')'
 				)) return false;
 
 		}
@@ -206,7 +206,7 @@
 			$sql = 'SELECT t.httptestid'.
 					' FROM httptest t, applications a'.
 					' WHERE t.applicationid=a.applicationid'.
-						' AND a.hostid='.$hostid.
+						' AND a.hostid='.zbx_dbstr($hostid).
 						' AND t.name='.zbx_dbstr($name);
 			$t = DBfetch(DBselect($sql));
 			if((isset($httptestid) && $t && ($t['httptestid'] != $httptestid)) || ($t && !isset($httptestid))){
@@ -214,7 +214,7 @@
 			}
 
 
-			$sql = 'SELECT applicationid FROM applications WHERE name='.zbx_dbstr($application).' AND hostid='.$hostid;
+			$sql = 'SELECT applicationid FROM applications WHERE name='.zbx_dbstr($application).' AND hostid='.zbx_dbstr($hostid);
 			if($applicationid = DBfetch(DBselect($sql))){
 				$applicationid = $applicationid['applicationid'];
 			}
@@ -232,16 +232,16 @@
 				$sql = 'UPDATE httptest SET '.
 					' applicationid='.$applicationid.', '.
 					' name='.zbx_dbstr($name).', '.
-					' authentication='.$authentication.', '.
+					' authentication='.zbx_dbstr($authentication).', '.
 					' http_user='.zbx_dbstr($http_user).', '.
 					' http_password='.zbx_dbstr($http_password).', '.
-					' delay='.$delay.', '.
-					' status='.$status.', '.
+					' delay='.zbx_dbstr($delay).', '.
+					' status='.zbx_dbstr($status).', '.
 					' agent='.zbx_dbstr($agent).', '.
 					' macros='.zbx_dbstr($macros).', '.
 					' error='.zbx_dbstr('').', '.
 					' curstate='.HTTPTEST_STATE_UNKNOWN.
-				' WHERE httptestid='.$httptestid;
+				' WHERE httptestid='.zbx_dbstr($httptestid);
 				if(!DBexecute($sql)){
 					throw new Exception('DBerror');
 				}
@@ -253,11 +253,11 @@
 					'httptestid' => $httptestid,
 					'applicationid' => $applicationid,
 					'name' => zbx_dbstr($name),
-					'authentication' => $authentication,
+					'authentication' => zbx_dbstr($authentication),
 					'http_user' => zbx_dbstr($http_user),
 					'http_password' => zbx_dbstr($http_password),
-					'delay' => $delay,
-					'status' => $status,
+					'delay' => zbx_dbstr($delay),
+					'status' => zbx_dbstr($status),
 					'agent' => zbx_dbstr($agent),
 					'macros' => zbx_dbstr($macros),
 					'curstate' => HTTPTEST_STATE_UNKNOWN,
@@ -288,7 +288,7 @@
 			}
 
 /* clean unneeded steps */
-			$sql = 'SELECT httpstepid FROM httpstep WHERE httptestid='.$httptestid;
+			$sql = 'SELECT httpstepid FROM httpstep WHERE httptestid='.zbx_dbstr($httptestid);
 			$db_steps = DBselect($sql);
 			while($step_data = DBfetch($db_steps)){
 				if(!isset($httpstepids[$step_data['httpstepid']])){
@@ -314,12 +314,12 @@
 			foreach($monitored_items as $item){
 				$item_data = DBfetch(DBselect('select i.itemid,i.history,i.trends,i.delta,i.valuemapid '.
 					' from items i, httptestitem hi '.
-					' where hi.httptestid='.$httptestid.' and hi.itemid=i.itemid '.
-					' and hi.type='.$item['httptestitemtype']));
+					' where hi.httptestid='.zbx_dbstr($httptestid).' and hi.itemid=i.itemid '.
+					' and hi.type='.zbx_dbstr($item['httptestitemtype'])));
 
 				if(!$item_data){
 					$item_data = DBfetch(DBselect('select i.itemid,i.history,i.trends,i.delta,i.valuemapid '.
-						' from items i where i.key_='.zbx_dbstr($item['key_']).' and i.hostid='.$hostid));
+						' from items i where i.key_='.zbx_dbstr($item['key_']).' and i.hostid='.zbx_dbstr($hostid)));
 				}
 
 				$item_args = array(
@@ -378,10 +378,10 @@
 
 				$httptestitemid = get_dbid('httptestitem', 'httptestitemid');
 
-				DBexecute('delete from httptestitem where itemid='.$itemid);
+				DBexecute('delete from httptestitem where itemid='.zbx_dbstr($itemid));
 
 				if(!DBexecute('insert into httptestitem (httptestitemid, httptestid, itemid, type) '.
-					' values ('.$httptestitemid.','.$httptestid.','.$itemid.','.$item['httptestitemtype'].')')){
+					' values ('.$httptestitemid.','.zbx_dbstr($httptestid).','.zbx_dbstr($itemid).','.zbx_dbstr($item['httptestitemtype']).')')){
 					throw new Exception('DBerror');
 				}
 			}
@@ -415,7 +415,7 @@
 
 		$db_httpstepitems = DBselect('SELECT DISTINCT * FROM httpstepitem WHERE '.DBcondition('httpstepid',$httpstepids));
 		while($httpstepitem_data = DBfetch($db_httpstepitems)){
-			if(!DBexecute('DELETE FROM httpstepitem WHERE httpstepitemid='.$httpstepitem_data['httpstepitemid'])) return false;
+			if(!DBexecute('DELETE FROM httpstepitem WHERE httpstepitemid='.zbx_dbstr($httpstepitem_data['httpstepitemid']))) return false;
 			if(!delete_item($httpstepitem_data['itemid'])) return false;
 		}
 
@@ -427,7 +427,7 @@
 
 		$httptests = array();
 		foreach($httptestids as $id => $httptestid){
-			$httptests[$httptestid] =  DBfetch(DBselect('SELECT * FROM httptest WHERE httptestid='.$httptestid));
+			$httptests[$httptestid] =  DBfetch(DBselect('SELECT * FROM httptest WHERE httptestid='.zbx_dbstr($httptestid)));
 		}
 
 		$db_httpstep = DBselect('SELECT DISTINCT s.httpstepid '.
@@ -464,17 +464,17 @@
 	}
 
 	function activate_httptest($httptestid){
-		$r = DBexecute('UPDATE httptest SET status='.HTTPTEST_STATUS_ACTIVE.' WHERE httptestid='.$httptestid);
+		$r = DBexecute('UPDATE httptest SET status='.HTTPTEST_STATUS_ACTIVE.' WHERE httptestid='.zbx_dbstr($httptestid));
 
 		$itemids = array();
-		$sql = 'SELECT hti.itemid FROM httptestitem hti WHERE hti.httptestid='.$httptestid;
+		$sql = 'SELECT hti.itemid FROM httptestitem hti WHERE hti.httptestid='.zbx_dbstr($httptestid);
 		$items_db = DBselect($sql);
 		while($itemid = Dbfetch($items_db)){
 			$itemids[] = $itemid['itemid'];
 		}
 
 		$sql = 'SELECT hsi.itemid FROM httpstep hs, httpstepitem hsi WHERE '.
-			' hs.httptestid='.$httptestid.' AND hs.httpstepid=hsi.httpstepid';
+			' hs.httptestid='.zbx_dbstr($httptestid).' AND hs.httpstepid=hsi.httpstepid';
 		$items_db = DBselect($sql);
 		while($itemid = Dbfetch($items_db)){
 			$itemids[] = $itemid['itemid'];
@@ -486,17 +486,17 @@
 	}
 
 	function disable_httptest($httptestid){
-		$r = DBexecute('UPDATE httptest SET status='.HTTPTEST_STATUS_DISABLED.' WHERE httptestid='.$httptestid);
+		$r = DBexecute('UPDATE httptest SET status='.HTTPTEST_STATUS_DISABLED.' WHERE httptestid='.zbx_dbstr($httptestid));
 
 		$itemids = array();
-		$sql = 'SELECT hti.itemid FROM httptestitem hti WHERE hti.httptestid='.$httptestid;
+		$sql = 'SELECT hti.itemid FROM httptestitem hti WHERE hti.httptestid='.zbx_dbstr($httptestid);
 		$items_db = DBselect($sql);
 		while($itemid = Dbfetch($items_db)){
 			$itemids[] = $itemid['itemid'];
 		}
 
 		$sql = 'SELECT hsi.itemid FROM httpstep hs, httpstepitem hsi WHERE '.
-			' hs.httptestid='.$httptestid.' AND hs.httpstepid=hsi.httpstepid';
+			' hs.httptestid='.zbx_dbstr($httptestid).' AND hs.httpstepid=hsi.httpstepid';
 		$items_db = DBselect($sql);
 		while($itemid = Dbfetch($items_db)){
 			$itemids[] = $itemid['itemid'];
@@ -510,7 +510,7 @@
 	function delete_history_by_httptestid($httptestid){
 		$db_items = DBselect('SELECT DISTINCT i.itemid '.
 							' FROM items i, httpstepitem si, httpstep s '.
-							' WHERE s.httptestid='.$httptestid.
+							' WHERE s.httptestid='.zbx_dbstr($httptestid).
 								' AND si.httpstepid=s.httpstepid '.
 								' AND i.itemid=si.itemid');
 		while($item_data = DBfetch($db_items)){
@@ -520,11 +520,11 @@
 	}
 
 	function get_httptest_by_httptestid($httptestid){
-		return DBfetch(DBselect('select * from httptest where httptestid='.$httptestid));
+		return DBfetch(DBselect('select * from httptest where httptestid='.zbx_dbstr($httptestid)));
 	}
 
 	function get_httpstep_by_no($httptestid, $no){
-		return DBfetch(DBselect('select * from httpstep where httptestid='.$httptestid.' and no='.$no));
+		return DBfetch(DBselect('select * from httpstep where httptestid='.zbx_dbstr($httptestid).' and no='.zbx_dbstr($no)));
 	}
 
 	function get_httptests_by_hostid($hostids){
Index: frontends/php/include/acknow.inc.php
===================================================================
--- frontends/php/include/acknow.inc.php	(revision 38884)
+++ frontends/php/include/acknow.inc.php	(working copy)
@@ -23,7 +23,7 @@
 function get_last_event_by_triggerid($triggerid){
 	$event_data = DBfetch(DBselect('SELECT * '.
 				' FROM events '.
-				' WHERE objectid='.$triggerid.
+				' WHERE objectid='.zbx_dbstr($triggerid).
 					' and object='.EVENT_OBJECT_TRIGGER.
 				' ORDER BY objectid desc, object desc, eventid desc', 1));
 	if(!$event_data)
@@ -32,7 +32,7 @@
 }
 
 function get_acknowledges_by_eventid($eventid){
-	return DBselect("SELECT a.*, u.alias FROM acknowledges a LEFT JOIN users u ON u.userid=a.userid  WHERE a.eventid=$eventid");
+	return DBselect('SELECT a.*, u.alias FROM acknowledges a LEFT JOIN users u ON u.userid=a.userid  WHERE a.eventid='.zbx_dbstr($eventid));
 }
 
 function make_acktab_by_eventid($eventid){
Index: frontends/php/include/forms.inc.php
===================================================================
--- frontends/php/include/forms.inc.php	(revision 38884)
+++ frontends/php/include/forms.inc.php	(working copy)
@@ -37,12 +37,12 @@
 		$new_step	= get_request('new_step', null);
 
 		if((isset($_REQUEST['slideshowid']) && !isset($_REQUEST['form_refresh']))){
-			$slideshow_data = DBfetch(DBselect('SELECT * FROM slideshows WHERE slideshowid='.$_REQUEST['slideshowid']));
+			$slideshow_data = DBfetch(DBselect('SELECT * FROM slideshows WHERE slideshowid='.zbx_dbstr($_REQUEST['slideshowid'])));
 
 			$name		= $slideshow_data['name'];
 			$delay		= $slideshow_data['delay'];
 			$steps		= array();
-			$db_steps = DBselect('SELECT * FROM slides WHERE slideshowid='.$_REQUEST['slideshowid'].' order by step');
+			$db_steps = DBselect('SELECT * FROM slides WHERE slideshowid='.zbx_dbstr($_REQUEST['slideshowid']).' order by step');
 
 			while($step_data = DBfetch($db_steps)){
 				$steps[$step_data['step']] = array(
@@ -233,7 +233,7 @@
 			$user_groups = zbx_objectValues($user_groups, 'usrgrpid');
 			$user_groups = zbx_toHash($user_groups);
 
-			$db_medias = DBselect('SELECT m.* FROM media m WHERE m.userid='.$userid);
+			$db_medias = DBselect('SELECT m.* FROM media m WHERE m.userid='.zbx_dbstr($userid));
 			while($db_media = DBfetch($db_medias)){
 				$user_medias[] = array(
 					'mediaid' => $db_media['mediaid'],
@@ -642,7 +642,7 @@
 			$sql = 'SELECT DISTINCT u.userid '.
 						' FROM users u,users_groups ug '.
 						' WHERE u.userid=ug.userid '.
-							' AND ug.usrgrpid='.$_REQUEST['usrgrpid'];
+							' AND ug.usrgrpid='.zbx_dbstr($_REQUEST['usrgrpid']);
 
 			$db_users=DBselect($sql);
 
@@ -654,7 +654,7 @@
 					' FROM groups g '.
 						' LEFT JOIN rights r on r.id=g.groupid '.
 						' LEFT JOIN nodes n on n.nodeid='.DBid2nodeid('g.groupid').
-					' WHERE r.groupid='.$_REQUEST['usrgrpid'];
+					' WHERE r.groupid='.zbx_dbstr($_REQUEST['usrgrpid']);
 
 			$db_rights = DBselect($sql);
 			while($db_right = DBfetch($db_rights)){
@@ -716,7 +716,7 @@
 	$sql_where = '';
 	if($selusrgrp > 0) {
 		$sql_from = ', users_groups g ';
-		$sql_where = ' AND u.userid=g.userid AND g.usrgrpid='.$selusrgrp;
+		$sql_where = ' AND u.userid=g.userid AND g.usrgrpid='.zbx_dbstr($selusrgrp);
 	}
 	$sql = 'SELECT DISTINCT u.userid, u.alias '.
 			' FROM users u '.$sql_from.
@@ -1670,7 +1670,7 @@
 			do{
 				$sql = 'SELECT i.itemid, i.templateid, h.host'.
 						' FROM items i, hosts h'.
-						' WHERE i.itemid='.$itemid.
+						' WHERE i.itemid='.zbx_dbstr($itemid).
 							' AND h.hostid=i.hostid';
 				$itemFromDb = DBfetch(DBselect($sql));
 				if($itemFromDb){
@@ -2096,7 +2096,7 @@
 
 		$sql = 'SELECT DISTINCT applicationid,name '.
 				' FROM applications '.
-				' WHERE hostid='.$hostid.
+				' WHERE hostid='.zbx_dbstr($hostid).
 				' ORDER BY name';
 		$db_applications = DBselect($sql);
 		while($db_app = DBfetch($db_applications)){
@@ -2368,7 +2368,7 @@
 		if(isset($_REQUEST['hostid'])){
 			$sql = 'SELECT applicationid,name '.
 				' FROM applications '.
-				' WHERE hostid='.$_REQUEST['hostid'].
+				' WHERE hostid='.zbx_dbstr($_REQUEST['hostid']).
 				' ORDER BY name';
 			$db_applications = DBselect($sql);
 			while($db_app = DBfetch($db_applications)){
@@ -2578,7 +2578,7 @@
 			do{
 				$sql = 'SELECT t.triggerid, t.templateid, h.host'.
 						' FROM triggers t, functions f, items i, hosts h'.
-						' WHERE t.triggerid='.$trigid.
+						' WHERE t.triggerid='.zbx_dbstr($trigid).
 							' AND h.hostid=i.hostid'.
 							' AND i.itemid=f.itemid'.
 							' AND f.triggerid=t.triggerid';
@@ -2627,7 +2627,7 @@
 				$trigs=DBselect('SELECT t.triggerid,t.description,t.expression '.
 							' FROM triggers t,trigger_depends d '.
 							' WHERE t.triggerid=d.triggerid_up '.
-								' AND d.triggerid_down='.$_REQUEST['triggerid']);
+								' AND d.triggerid_down='.zbx_dbstr($_REQUEST['triggerid']));
 
 				while($trig=DBfetch($trigs)){
 					if(uint_in_array($trig['triggerid'],$dependencies))	continue;
@@ -3666,7 +3666,7 @@
 		if(isset($_REQUEST['screenid'])){
 			$result=DBselect('SELECT screenid,name,hsize,vsize '.
 						' FROM screens g '.
-						' WHERE screenid='.$_REQUEST['screenid']);
+						' WHERE screenid='.zbx_dbstr($_REQUEST['screenid']));
 			$row=DBfetch($result);
 			$frm_title = S_SCREEN.' "'.$row['name'].'"';
 		}
@@ -4202,7 +4202,7 @@
 			$host_groups = zbx_objectValues($host_groups, 'groupid');
 
 // read profile
-			$db_profiles = DBselect('SELECT * FROM hosts_profiles WHERE hostid='.$_REQUEST['hostid']);
+			$db_profiles = DBselect('SELECT * FROM hosts_profiles WHERE hostid='.zbx_dbstr($_REQUEST['hostid']));
 
 			$useprofile = 'no';
 			$db_profile = DBfetch($db_profiles);
@@ -4225,7 +4225,7 @@
 // BEGIN: HOSTS PROFILE EXTENDED Section
 			$useprofile_ext = 'no';
 
-			$db_profiles_alt = DBselect('SELECT * FROM hosts_profiles_ext WHERE hostid='.$_REQUEST['hostid']);
+			$db_profiles_alt = DBselect('SELECT * FROM hosts_profiles_ext WHERE hostid='.zbx_dbstr($_REQUEST['hostid']));
 			if($ext_host_profiles = DBfetch($db_profiles_alt)){
 				$useprofile_ext = 'yes';
 			}
@@ -4648,7 +4648,7 @@
 
 		$sql_fields = implode(', ', array_keys($table_titles)); //generate string of fields to get from DB
 
-		$sql = 'SELECT '.$sql_fields.' FROM hosts_profiles WHERE hostid='.$_REQUEST['hostid'];
+		$sql = 'SELECT '.$sql_fields.' FROM hosts_profiles WHERE hostid='.zbx_dbstr($_REQUEST['hostid']);
 		$result = DBselect($sql);
 
 		if($row = DBfetch($result)) {
@@ -4689,7 +4689,7 @@
 				'poc_2_screen' => S_POC_2_SCREEN, 'poc_2_notes' => S_POC_2_NOTES);
 
 		$sql_fields = implode(', ', array_keys($table_titles)); //generate string of fields to get from DB
-		$result = DBselect('SELECT '.$sql_fields.' FROM hosts_profiles_ext WHERE hostid='.$_REQUEST['hostid']);
+		$result = DBselect('SELECT '.$sql_fields.' FROM hosts_profiles_ext WHERE hostid='.zbx_dbstr($_REQUEST['hostid']));
 
 		if($row = DBfetch($result)) {
 			foreach($row as $key => $value) {
@@ -4852,7 +4852,7 @@
 			$sql = 'SELECT re.* '.
 				' FROM regexps re '.
 				' WHERE '.DBin_node('re.regexpid').
-					' AND re.regexpid='.$_REQUEST['regexpid'];
+					' AND re.regexpid='.zbx_dbstr($_REQUEST['regexpid']);
 			$regexp = DBfetch(DBSelect($sql));
 
 			$frm_title .= ' ['.$regexp['name'].']';
@@ -4864,7 +4864,7 @@
 			$sql = 'SELECT e.* '.
 					' FROM expressions e '.
 					' WHERE '.DBin_node('e.expressionid').
-						' AND e.regexpid='.$regexp['regexpid'].
+						' AND e.regexpid='.zbx_dbstr($regexp['regexpid']).
 					' ORDER BY e.expression_type';
 
 			$db_exps = DBselect($sql);
@@ -5006,7 +5006,7 @@
 			$sql = 'SELECT e.* '.
 					' FROM expressions e '.
 					' WHERE '.DBin_node('e.expressionid').
-						' AND e.regexpid='.$_REQUEST['regexpid'].
+						' AND e.regexpid='.zbx_dbstr($_REQUEST['regexpid']).
 					' ORDER BY e.expression_type';
 
 			$db_exps = DBselect($sql);
Index: frontends/php/include/triggers.inc.php
===================================================================
--- frontends/php/include/triggers.inc.php	(revision 38884)
+++ frontends/php/include/triggers.inc.php	(working copy)
@@ -132,7 +132,7 @@
 	function get_service_status_of_trigger($triggerid){
 		$sql = 'SELECT triggerid, priority '.
 				' FROM triggers '.
-				' WHERE triggerid='.$triggerid.
+				' WHERE triggerid='.zbx_dbstr($triggerid).
 					' AND status='.TRIGGER_STATUS_ENABLED.
 					' AND value='.TRIGGER_VALUE_TRUE;
 
@@ -322,7 +322,7 @@
 	}
 
 	function get_functions_by_triggerid($triggerid){
-		return DBselect('select * from functions where triggerid='.$triggerid);
+		return DBselect('select * from functions where triggerid='.zbx_dbstr($triggerid));
 	}
 
 /*
@@ -340,7 +340,7 @@
 	function get_triggers_by_hostid($hostid){
 		$db_triggers = DBselect('SELECT DISTINCT t.* '.
 								' FROM triggers t, functions f, items i '.
-								' WHERE i.hostid='.$hostid.
+								' WHERE i.hostid='.zbx_dbstr($hostid).
 									' AND f.itemid=i.itemid '.
 									' AND f.triggerid=t.triggerid');
 	return $db_triggers;
@@ -550,8 +550,8 @@
 
 		$result = DBexecute('INSERT INTO triggers '.
 			'  (triggerid,description,type,priority,status,comments,url,value,error,templateid) '.
-			" values ($triggerid,".zbx_dbstr($description).",$type,$priority,$status,".zbx_dbstr($comments).','.
-			zbx_dbstr($url).",2,'Trigger just added. No status update so far.',$templateid)");
+			' values ('.$triggerid.','.zbx_dbstr($description).','.zbx_dbstr($type).','.zbx_dbstr($priority).','.zbx_dbstr($status).','.zbx_dbstr($comments).','.
+			zbx_dbstr($url).',2,\'Trigger just added. No status update so far.\','.zbx_dbstr($templateid).')');
 
 		if (!$result) {
 			return	$result;
@@ -564,7 +564,7 @@
 			return false;
 		}
 
-		DBexecute('update triggers set expression='.zbx_dbstr($expression).' where triggerid='.$triggerid);
+		DBexecute('update triggers set expression='.zbx_dbstr($expression).' where triggerid='.zbx_dbstr($triggerid));
 
 		$trig_hosts = get_hosts_by_triggerid($triggerid);
 		$trig_host = DBfetch($trig_hosts);
@@ -618,13 +618,13 @@
 					// $hostid);
 		$sql='SELECT t2.triggerid, t2.expression '.
 				' FROM triggers t2, functions f1, functions f2, items i1, items i2 '.
-				' WHERE f1.triggerid='.$triggerid.
+				' WHERE f1.triggerid='.zbx_dbstr($triggerid).
 					' AND i1.itemid=f1.itemid '.
 					' AND f2.function=f1.function '.
 					' AND f2.parameter=f1.parameter '.
 					' AND i2.itemid=f2.itemid '.
 					' AND i2.key_=i1.key_ '.
-					' AND i2.hostid='.$hostid.
+					' AND i2.hostid='.zbx_dbstr($hostid).
 					' AND t2.triggerid=f2.triggerid '.
 					' AND t2.description='.zbx_dbstr($trigger['description']).
 					' AND t2.templateid=0 ';
@@ -650,9 +650,9 @@
 
 		$result = DBexecute('INSERT INTO triggers '.
 					' (triggerid,description,type,priority,status,comments,url,value,expression,templateid)'.
-					' VALUES ('.$newtriggerid.','.zbx_dbstr($trigger['description']).','.$trigger['type'].','.$trigger['priority'].','.
-					$trigger['status'].','.zbx_dbstr($trigger['comments']).','.
-					zbx_dbstr($trigger['url']).",2,'0',".($copy_mode ? 0 : $triggerid).')');
+					' VALUES ('.$newtriggerid.','.zbx_dbstr($trigger['description']).','.zbx_dbstr($trigger['type']).','.zbx_dbstr($trigger['priority']).','.
+					zbx_dbstr($trigger['status']).','.zbx_dbstr($trigger['comments']).','.
+					zbx_dbstr($trigger['url']).",2,'0',".($copy_mode ? 0 : zbx_dbstr($triggerid)).')');
 
 		if(!$result)
 			return $result;
@@ -665,7 +665,7 @@
 		while($function = DBfetch($functions)){
 			$item = get_item_by_itemid($function['itemid']);
 
-			$host_items = DBselect('SELECT * FROM items WHERE key_='.zbx_dbstr($item['key_']).' AND hostid='.$host['hostid']);
+			$host_items = DBselect('SELECT * FROM items WHERE key_='.zbx_dbstr($item['key_']).' AND hostid='.zbx_dbstr($host['hostid']));
 			$host_item = DBfetch($host_items);
 			if(!$host_item){
 				error(S_MISSING_KEY.SPACE.'"'.$item['key_'].'"'.SPACE.S_FOR_HOST_SMALL.SPACE.'"'.$host['host'].'"');
@@ -675,7 +675,7 @@
 			$newfunctionid=get_dbid('functions','functionid');
 
 			$result = DBexecute('INSERT INTO functions (functionid,itemid,triggerid,function,parameter) '.
-				" values ($newfunctionid,".$host_item['itemid'].','.$newtriggerid.','.
+				' values ('.zbx_dbstr($newfunctionid).','.zbx_dbstr($host_item['itemid']).','.zbx_dbstr($newtriggerid).','.
 				zbx_dbstr($function['function']).','.zbx_dbstr($function['parameter']).')');
 
 			$newexpression = str_replace(
@@ -684,7 +684,7 @@
 				$newexpression);
 		}
 
-		DBexecute('UPDATE triggers SET expression='.zbx_dbstr($newexpression).' WHERE triggerid='.$newtriggerid);
+		DBexecute('UPDATE triggers SET expression='.zbx_dbstr($newexpression).' WHERE triggerid='.zbx_dbstr($newtriggerid));
 
 		info(S_ADDED_TRIGGER.SPACE.'"'.$host['host'].':'.$trigger['description'].'"');
 		add_audit_ext(AUDIT_ACTION_ADD, AUDIT_RESOURCE_TRIGGER, $newtriggerid, $host['host'].':'.$trigger['description'], NULL, NULL, NULL);
@@ -870,7 +870,7 @@
 				$state='';
 				$sql = 'SELECT h.host,i.itemid,i.key_,f.function,f.triggerid,f.parameter,i.itemid,i.status, i.type'.
 						' FROM items i,functions f,hosts h'.
-						' WHERE f.functionid='.$functionid.
+						' WHERE f.functionid='.zbx_dbstr($functionid).
 							' AND i.itemid=f.itemid '.
 							' AND h.hostid=i.hostid';
 
@@ -1243,7 +1243,7 @@
 							' FROM functions f,items i,hosts h'.
 							' WHERE f.itemid=i.itemid'.
 								' AND i.hostid=h.hostid'.
-								' AND f.functionid='.$functionid;
+								' AND f.functionid='.zbx_dbstr($functionid);
 					$host = DBfetch(DBselect($sql));
 					if (is_null($host['host'])) {
 						$host['host'] = $macro;
@@ -1261,7 +1261,7 @@
 					$sql = 'SELECT i.lastvalue,i.value_type,i.itemid,i.valuemapid,i.units'.
 							' FROM items i,functions f'.
 							' WHERE i.itemid=f.itemid'.
-							' AND f.functionid='.$functionid;
+							' AND f.functionid='.zbx_dbstr($functionid);
 					$itemData = DBfetch(DBselect($sql));
 					$description = str_replace($macro, format_lastvalue($itemData), $description);
 				}
@@ -1276,7 +1276,7 @@
 						$sql = 'SELECT i.value_type,i.itemid,i.valuemapid,i.units'.
 								' FROM items i,functions f'.
 								' WHERE i.itemid=f.itemid'.
-								' AND f.functionid='.$functionid;
+								' AND f.functionid='.zbx_dbstr($functionid);
 						$itemData = DBfetch(DBselect($sql));
 					}
 
@@ -1309,7 +1309,7 @@
 				' WHERE f.triggerid=t.triggerid '.
 					' AND i.itemid=f.itemid '.
 					' AND h.hostid=i.hostid '.
-					' AND t.triggerid='.$triggerid;
+					' AND t.triggerid='.zbx_dbstr($triggerid);
 		$trigger = DBfetch(DBselect($sql));
 
 	return expand_trigger_description_by_data($trigger);
@@ -1341,7 +1341,7 @@
 		}
 
 		if(!empty($triggers)){
-			DBexecute('UPDATE triggers SET value='.TRIGGER_VALUE_UNKNOWN.', lastchange='.$now.' WHERE '.DBcondition('triggerid',$triggers));
+			DBexecute('UPDATE triggers SET value='.TRIGGER_VALUE_UNKNOWN.', lastchange='.zbx_dbstr($now).' WHERE '.DBcondition('triggerid',$triggers));
 		}
 	return true;
 	}
@@ -1660,7 +1660,7 @@
 	function get_trigger_dependencies_by_triggerid($triggerid){
 		$result = array();
 
-		$db_deps = DBselect('SELECT * FROM trigger_depends WHERE triggerid_down='.$triggerid);
+		$db_deps = DBselect('SELECT * FROM trigger_depends WHERE triggerid_down='.zbx_dbstr($triggerid));
 		while($db_dep = DBfetch($db_deps))
 			$result[] = $db_dep['triggerid_up'];
 
@@ -1742,7 +1742,7 @@
 	function insert_dependency($triggerid_down, $triggerid_up) {
 		$triggerdepid = get_dbid('trigger_depends', 'triggerdepid');
 		return DBexecute('INSERT INTO trigger_depends (triggerdepid,triggerid_down,triggerid_up)'.
-				' VALUES ('.$triggerdepid.','.$triggerid_down.','.$triggerid_up.')');
+				' VALUES ('.$triggerdepid.','.zbx_dbstr($triggerid_down).','.zbx_dbstr($triggerid_up).')');
 	}
 
 	function replace_triggers_depenedencies($new_triggerids){
@@ -1771,10 +1771,10 @@
 		foreach($deps as $id => $val){
 			$sql = 'SELECT t.triggerid '.
 				' FROM triggers t,functions f,items i '.
-				' WHERE t.templateid='.$val.
+				' WHERE t.templateid='.zbx_dbstr($val).
 					' AND f.triggerid=t.triggerid '.
 					' AND f.itemid=i.itemid '.
-					' AND i.hostid='.$hostid;
+					' AND i.hostid='.zbx_dbstr($hostid);
 			if($db_new_dep = DBfetch(DBselect($sql))){
 				$deps[$id] = $db_new_dep['triggerid'];
 			}
@@ -1810,7 +1810,7 @@
 		$level++;
 		$result = true;
 
-		$sql = 'SELECT triggerid_up FROM trigger_depends WHERE triggerid_down='.$triggerid_up;
+		$sql = 'SELECT triggerid_up FROM trigger_depends WHERE triggerid_down='.zbx_dbstr($triggerid_up);
 		$res = DBselect($sql);
 		while(($trig = DBfetch($res)) && $result){
 			$result &= check_dependency_by_triggerid($triggerid,$trig['triggerid_up'],$level);		// RECURSION!!!
@@ -2041,7 +2041,7 @@
 			}
 
 			if ($unlink_mode) {
-				if (DBexecute('UPDATE triggers SET templateid=0 WHERE triggerid='.$trigger['triggerid'])) {
+				if (DBexecute('UPDATE triggers SET templateid=0 WHERE triggerid='.zbx_dbstr($trigger['triggerid']))) {
 					info(sprintf(S_TRIGGER_UNLINKED, $host['host'].':'.$trigger['description']));
 				}
 			}
@@ -2296,7 +2296,7 @@
 			$dep_table->setAttribute('style', 'width: 200px;');
 			$dep_table->addRow(bold(S_DEPENDS_ON.':'));
 
-			$sql_dep = 'SELECT * FROM trigger_depends WHERE triggerid_down='.$triggerid;
+			$sql_dep = 'SELECT * FROM trigger_depends WHERE triggerid_down='.zbx_dbstr($triggerid);
 			$dep_res = DBselect($sql_dep);
 			while($dep_row = DBfetch($dep_res)){
 				$dep_table->addRow(SPACE.'-'.SPACE.expand_trigger_description($dep_row['triggerid_up']));
@@ -2318,7 +2318,7 @@
 			$dep_table->setAttribute('style', 'width: 200px;');
 			$dep_table->addRow(bold(S_DEPENDENT.':'));
 
-			$sql_dep = 'SELECT * FROM trigger_depends WHERE triggerid_up='.$triggerid;
+			$sql_dep = 'SELECT * FROM trigger_depends WHERE triggerid_up='.zbx_dbstr($triggerid);
 			$dep_res = DBselect($sql_dep);
 			while($dep_row = DBfetch($dep_res)){
 				$dep_table->addRow(SPACE.'-'.SPACE.expand_trigger_description($dep_row['triggerid_down']));
@@ -2363,9 +2363,9 @@
 		if(($period_start>0) && ($period_start <= time())){
 			$sql='SELECT e.eventid, e.value '.
 					' FROM events e '.
-					' WHERE e.objectid='.$triggerid.
+					' WHERE e.objectid='.zbx_dbstr($triggerid).
 						' AND e.object='.EVENT_OBJECT_TRIGGER.
-						' AND e.clock<'.$period_start.
+						' AND e.clock<'.zbx_dbstr($period_start).
 					' ORDER BY e.eventid DESC';
 			if($row = DBfetch(DBselect($sql,1))){
 				$start_value = $row['value'];
@@ -2375,11 +2375,11 @@
 
 		$sql='SELECT COUNT(*) as cnt, MIN(clock) as minn, MAX(clock) as maxx '.
 				' FROM events '.
-				' WHERE objectid='.$triggerid.
+				' WHERE objectid='.zbx_dbstr($triggerid).
 					' AND object='.EVENT_OBJECT_TRIGGER;
 
-		if($period_start!=0)	$sql .= ' AND clock>='.$period_start;
-		if($period_end!=0)		$sql .= ' AND clock<='.$period_end;
+		if($period_start!=0)	$sql .= ' AND clock>='.zbx_dbstr($period_start);
+		if($period_end!=0)		$sql .= ' AND clock<='.zbx_dbstr($period_end);
 //SDI($sql);
 
 		$row=DBfetch(DBselect($sql));
@@ -2419,10 +2419,10 @@
 		$rows=0;
 		$sql = 'SELECT eventid,clock,value '.
 				' FROM events '.
-				' WHERE objectid='.$triggerid.
+				' WHERE objectid='.zbx_dbstr($triggerid).
 					' AND object='.EVENT_OBJECT_TRIGGER.
-					' AND clock>='.$min.
-					' AND clock<='.$max.
+					' AND clock>='.zbx_dbstr($min).
+					' AND clock<='.zbx_dbstr($max).
 				' ORDER BY clock ASC, eventid ASC';
 		$result=DBselect($sql);
 		while($row=DBfetch($result)){
@@ -2506,7 +2506,7 @@
 
 		$sql = 'SELECT t.triggerid, t.value '.
 				' FROM trigger_depends d, triggers t '.
-				' WHERE d.triggerid_down='.$triggerid.
+				' WHERE d.triggerid_down='.zbx_dbstr($triggerid).
 					' AND d.triggerid_up=t.triggerid';
 
 		$result = DBselect($sql);
@@ -2589,7 +2589,7 @@
 		$functionid=trigger_get_N_functionid($expression,$function);
 		if(isset($functionid)){
 			$row=DBfetch(DBselect('select i.* from items i, functions f '.
-				' where i.itemid=f.itemid and f.functionid='.$functionid));
+				' where i.itemid=f.itemid and f.functionid='.zbx_dbstr($functionid)));
 			if($row)
 			{
 				$result=($flag == ZBX_FLAG_TRIGGER)?
